function sp3depict(){
arrays=gl3d();
wgl(arrays[0],arrays[1]);
}
function gl3d(){
var sceneX=5;
var sceneY=5;
var sceneZ=5;
var sceneShiftX=-sceneX/2;
var sceneShiftY=-sceneY/2;
var sceneShiftZ=-sceneZ/2;
var pn=2;
var spn=spectrums.length;
var chrn=spectrums[0].length;
var colr=1/(zmax-zmin);
var zdiff=sceneZ/(zmax-zmin);
var vertices = new Array;
var colors = new Array;
var arrays = new Array;

for(var i=0;i<spn-1;i=i+1){//перебор спектров

for(j=0;j<chrn-1;j=j+1){//перебор точек спектра
var curZ=spectrums[i][j];
var curZ1=spectrums[i+1][j];
var arrayPointer=(i*chrn+j)*3*pn;

vertices[arrayPointer+0]=sceneX/spn*i+sceneShiftX;
vertices[arrayPointer+1]=sceneY/chrn*j+sceneShiftY;
vertices[arrayPointer+2]=zdiff*(curZ-zmin)+sceneShiftZ;

var clr=colorDiagram(colr*(curZ-zmin));
colors[arrayPointer+0]=clr[0];
colors[arrayPointer+1]=clr[1];
colors[arrayPointer+2]=clr[2];

vertices[arrayPointer+3]=sceneX/spn*(i+1)+sceneShiftX;
vertices[arrayPointer+4]=sceneY/chrn*j+sceneShiftY;
vertices[arrayPointer+5]=zdiff*(curZ1-zmin)+sceneShiftZ;

var clr=colorDiagram(colr*(curZ1-zmin));
colors[arrayPointer+3]=clr[0];
colors[arrayPointer+4]=clr[1];
colors[arrayPointer+5]=clr[2];

}

}

arrays[0]=vertices;
arrays[1]=colors;
return arrays;
}
function wgl(vertices,colors){
/*============= Creating a canvas ======================*/
var canvaswgl = document.getElementById('my_Canvas');
gl = canvaswgl.getContext('experimental-webgl');
//alert(document.getElementById('my_Canvas').offsetTop+" "+document.getElementById('my_Canvas').offsetLeft);
/*========== Defining and storing the geometry ==========*/
// Create and store data into vertex buffer
try{var vertex_buffer = gl.createBuffer ();}
catch(TypeError){
document.getElementById("nowgl").style.visibility="visible";
var top=document.getElementById('my_Canvas').offsetTop+200;
var left=document.getElementById('my_Canvas').offsetLeft+200;
document.getElementById("nowgl").style.top=top+"px";
document.getElementById("nowgl").style.left=left+"px";
}

gl.bindBuffer(gl.ARRAY_BUFFER, vertex_buffer);
gl.bufferData(gl.ARRAY_BUFFER,
new Float32Array(vertices), gl.STATIC_DRAW);
// Create and store data into color buffer
var color_buffer = gl.createBuffer ();
gl.bindBuffer(gl.ARRAY_BUFFER, color_buffer);
gl.bufferData(gl.ARRAY_BUFFER,
new Float32Array(colors), gl.STATIC_DRAW);

/*=================== SHADERS =================== */
var vertCode='attribute vec3 position;'+
'uniform mat4 Pmatrix;'+
'uniform mat4 Vmatrix;'+
'uniform mat4 Mmatrix;'+
'attribute vec3 color;'+//the color of the point
'varying vec3 vColor;'+
'void main(void) { '+//pre-built function
'gl_Position = Pmatrix*Vmatrix*Mmatrix*vec4(position, 1.);'+
'vColor=color;'+
'}';
var fragCode='precision mediump float;'+
'varying vec3 vColor;'+
'void main(void) {'+
'gl_FragColor = vec4(vColor, 1.);'+
'}';
var vertShader = gl.createShader(gl.VERTEX_SHADER);
gl.shaderSource(vertShader, vertCode);
gl.compileShader(vertShader);
var fragShader = gl.createShader(gl.FRAGMENT_SHADER);
gl.shaderSource(fragShader, fragCode);
gl.compileShader(fragShader);
var shaderprogram=gl.createProgram();
gl.attachShader(shaderprogram, vertShader);
gl.attachShader(shaderprogram, fragShader);
gl.linkProgram(shaderprogram);
/*======== Associating attributes to vertex shader =====*/
var _Pmatrix = gl.getUniformLocation(shaderprogram, "Pmatrix");
var _Vmatrix = gl.getUniformLocation(shaderprogram, "Vmatrix");
var _Mmatrix = gl.getUniformLocation(shaderprogram, "Mmatrix");
gl.bindBuffer(gl.ARRAY_BUFFER, vertex_buffer);
var _position = gl.getAttribLocation(shaderprogram, "position" );
gl.vertexAttribPointer(_position, 3, gl.FLOAT, false,0,0);
gl.enableVertexAttribArray(_position);
gl.bindBuffer(gl.ARRAY_BUFFER, color_buffer);
var _color = gl.getAttribLocation(shaderprogram, "color");
gl.vertexAttribPointer(_color, 3, gl.FLOAT, false,0,0) ;
gl.enableVertexAttribArray(_color);
gl.useProgram(shaderprogram);
/*==================== MATRIX ====================== */
function get_projection(angle, a, zMin, zMax) {
var ang=Math.tan((angle*.5)*Math.PI/180);//angle*.5
return [
0.5/ang, 0 , 0, 0,
0, 0.5*a/ang, 0, 0,
0, 0, -(zMax+zMin)/(zMax-zMin), -1,
0, 0, (-2*zMax*zMin)/(zMax-zMin), 0 ];
}
var proj_matrix=get_projection(40,
canvaswgl.width/canvaswgl.height, 1, 100);
var mo_matrix=[
1,0,0,0,
0,1,0,0,
0,0,1,0,
0,0,0,1];
var view_matrix=[
1,0,0,0,
0,1,0,0,
0,0,1,0,
0,0,0,1];
view_matrix[14]=view_matrix[14]-6;
gl.uniformMatrix4fv(_Pmatrix, false, proj_matrix);
gl.uniformMatrix4fv(_Vmatrix, false, view_matrix);
/*================= Mouse events ======================*/
//var AMORTIZATION=0.001;
var drag=false;
var old_x, old_y;
var dX=0, dY=0;
var mouseDown=function(e) {
drag=true;
old_x=e.pageX, old_y=e.pageY;
e.preventDefault();
return false;
};
var mouseUp=function(e){
THETA=0;
PHI=0;
drag=false;
};
var mouseMove=function(e) {
if (!drag) return false;
if (dX>0&&e.pageX-old_x<0){THETA=0;}
if (dX<0&&e.pageX-old_x>0){THETA=0;}
if (dY>0&&e.pageY-old_y<0){PHI=0;}
if (dY<0&&e.pageY-old_y>0){PHI=0;}
dX=(e.pageX-old_x)*2*Math.PI/canvaswgl.width/10,
dY=(e.pageY-old_y)*2*Math.PI/canvaswgl.height/10;

THETA+=dX;
PHI+=dY;
old_x=e.pageX, old_y=e.pageY;
e.preventDefault();
//document.getElementById("x").innerHTML=THETA;//e.pageX;
//document.getElementById("y").innerHTML=PHI;//e.pageY;
window.requestAnimationFrame(animate);
};
canvaswgl.addEventListener("mousedown", mouseDown, false);
canvaswgl.addEventListener("mouseup", mouseUp, false);
canvaswgl.addEventListener("mouseout", mouseUp, false);
canvaswgl.addEventListener("mousemove", mouseMove, false);
/*================= Touch events ======================*/
//var AMORTIZATION=0.001;
var drag=false;
var old_x, old_y;
var dX=0, dY=0;
var touchDown=function(e) {
drag=true;
old_x=e.touches[0].pageX, old_y=e.touches[0].pageY;
e.preventDefault();
return false;
};
var touchUp=function(e){
THETA=0;
PHI=0;
drag=false;
};
var touchMove=function(e) {
if (!drag) return false;
if (!drag) return false;
if (dX>0&&e.touches[0].pageX-old_x<0){THETA=0;}
if (dX<0&&e.touches[0].pageX-old_x>0){THETA=0;}
if (dY>0&&e.touches[0].pageY-old_y<0){PHI=0;}
if (dY<0&&e.touches[0].pageY-old_y>0){PHI=0;}
dX=(e.touches[0].pageX-old_x)*2*Math.PI/canvaswgl.width/10,
dY=(e.touches[0].pageY-old_y)*2*Math.PI/canvaswgl.height/10;
THETA+=dX;
PHI+=dY;
old_x=e.touches[0].pageX, old_y=e.touches[0].pageY;
e.preventDefault();
window.requestAnimationFrame(animate);
};
//canvaswgl.addEventListener("touchenter", touchDown, false);
canvaswgl.addEventListener("touchstart", touchDown, false);
canvaswgl.addEventListener("touchend", touchUp, false);
//canvaswgl.addEventListener("touchleave", touchUp, false);
canvaswgl.addEventListener("touchmove", touchMove, false);
/*=========================rotation================*/
function rotateX(m, angle) {
var c=Math.cos(angle);
var s=Math.sin(angle);
var mv1=m[1], mv5=m[5], mv9=m[9];
m[1]=m[1]*c-m[2]*s;
m[5]=m[5]*c-m[6]*s;
m[9]=m[9]*c-m[10]*s;
m[2]=m[2]*c+mv1*s;
m[6]=m[6]*c+mv5*s;
m[10]=m[10]*c+mv9*s;
}
function rotateY(m, angle) {
var c=Math.cos(angle);
var s=Math.sin(angle);
var mv0=m[0], mv4=m[4], mv8=m[8];
m[0]=c*m[0]+s*m[2];
m[4]=c*m[4]+s*m[6];
m[8]=c*m[8]+s*m[10];
m[2]=c*m[2]-s*mv0;
m[6]=c*m[6]-s*mv4;
m[10]=c*m[10]-s*mv8;
}
/*=================== Drawing =================== */
var THETA=0,
PHI=0;
var time_old=0;
var animate=function(time) {
var dt=time-time_old;
if (!drag) {
THETA+=dX, PHI+=dY;
}

//set model matrix to I4

rotateY(mo_matrix, THETA);
rotateX(mo_matrix, PHI);
time_old=time;
gl.enable(gl.DEPTH_TEST);
gl.depthFunc(gl.LEQUAL);
gl.clearColor(0.6, 0.6, 0.6, 7.5);
gl.clearDepth(1.0);
gl.viewport(0.0, 0.0, canvaswgl.width, canvaswgl.height);
gl.clear(gl.COLOR_BUFFER_BIT | gl.DEPTH_BUFFER_BIT);

gl.uniformMatrix4fv(_Mmatrix, false, mo_matrix);
//gl.drawArrays(gl.POINTS,0,vertices.length/3);
//gl.drawArrays(gl.LINES,0,vertices.length/3);
//alert(vertices.length/3);
gl.drawArrays(gl.TRIANGLE_STRIP,0,vertices.length/3);
//window.requestAnimationFrame(animate);
}
animate(0);
}

function colorDiagram(value){
/*convert to long rainbow RGB*/
var clr=new Array;
var f=value;
var a=(1-f)*5;
var X1=Math.floor(a);
var Y=(1*(a-X1));
switch(X1)
{
case 0: r=1;g=Y;b=0;break;
case 1: r=1-Y;g=1;b=0;break;
case 2: r=0;g=1;b=Y;break;
case 3: r=0;g=1-Y;b=1;break;
case 4: r=Y;g=0;b=1;break;
case 5: r=1;g=0;b=1;break;
}
clr[0]=r;
clr[1]=g;
clr[2]=b;
//if(r>1||g>1||b>1||value>1){alert("r="+r+" "+"g="+g+" "+"b="+b+" "+value);}
return clr;
}

